VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6885
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5910
   LinkTopic       =   "Form1"
   ScaleHeight     =   6885
   ScaleWidth      =   5910
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstResults 
      Height          =   3180
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   11
      Top             =   3600
      Width           =   5655
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   495
      Left            =   4200
      TabIndex        =   10
      Top             =   2640
      Width           =   1215
   End
   Begin VB.TextBox txtYears 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2040
      TabIndex        =   9
      Text            =   "35"
      Top             =   3240
      Width           =   1695
   End
   Begin VB.TextBox txtInterestRate 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2040
      TabIndex        =   7
      Text            =   "9%"
      Top             =   2880
      Width           =   1695
   End
   Begin VB.TextBox txtTaxRate 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2040
      TabIndex        =   5
      Text            =   "20%"
      Top             =   2520
      Width           =   1695
   End
   Begin VB.TextBox txtAnnualContribution 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2040
      TabIndex        =   3
      Text            =   "$4,000.00"
      Top             =   2160
      Width           =   1695
   End
   Begin VB.Frame Frame1 
      Caption         =   "WARNING:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5655
      Begin VB.Label Label1 
         Caption         =   $"Form1.frx":0000
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   1455
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   5295
      End
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Years:"
      Height          =   195
      Index           =   3
      Left            =   120
      TabIndex        =   8
      Top             =   3240
      Width           =   450
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Annual interest rate:"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   6
      Top             =   2880
      Width           =   1410
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Income tax rate:"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   2520
      Width           =   1140
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Annual contribution:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   2160
      Width           =   1410
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const LB_SETTABSTOPS = &H192

Private Sub Form_Load()
Dim tabs(1 To 2) As Long

    tabs(1) = 50
    tabs(2) = 150

    ' Set the tabs.
    SendMessage lstResults.hwnd, LB_SETTABSTOPS, 2, tabs(1)
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - 2 * lstResults.Left
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - lstResults.Top - lstResults.Left
    If hgt < 120 Then hgt = 120
    lstResults.Width = wid
    lstResults.Height = hgt
End Sub

Private Sub cmdGo_Click()
Dim annual_contribution As Single
Dim tax_rate As Single
Dim interest_rate As Single
Dim num_years As Integer
Dim balance_bank As Single
Dim balance_401k As Single
Dim i As Integer

    annual_contribution = _
        Val(Replace(Replace(txtAnnualContribution.Text, "$", ""), ",", ""))

    tax_rate = Val(Replace(txtTaxRate.Text, "%", "")) / 100
    ' See how big it is.
    If tax_rate >= 1 Then
        ' It's a percentage as in 5%.
        tax_rate = tax_rate / 100
    End If

    interest_rate = Val(Replace(txtInterestRate.Text, "%", "")) / 100
    ' See how big it is.
    If interest_rate >= 1 Then
        ' It's a percentage as in 5%.
        interest_rate = interest_rate / 100
    End If

    num_years = Val(txtYears.Text)

    balance_bank = 0
    balance_401k = 0
    lstResults.Clear
    lstResults.AddItem "Year" & vbTab & "Bank" & vbTab & "401(k)"
    For i = 0 To num_years
        lstResults.AddItem i & vbTab & _
            FormatCurrency(balance_bank) & vbTab & _
            FormatCurrency(balance_401k)

        ' Bank balance += interest + contribution, minus taxes.
        balance_bank = balance_bank + _
            (1 - tax_rate) * (balance_bank * interest_rate + annual_contribution)

        ' 401(k) balance += interest + contribution.
        balance_401k = balance_401k + _
            (balance_401k * interest_rate + annual_contribution)
    Next i
End Sub


